Debian Bug report logs - #681579
live-boot + FAI fails: tmpfs seems to hide mounted image

version graph

Package: live-boot; Maintainer for live-boot is Live Systems Maintainers <debian-live@lists.debian.org>; Source for live-boot is src:live-boot.

Reported by: "Andreas B. Mundt" <andi.mundt@web.de>

Date: Sat, 14 Jul 2012 13:15:02 UTC

Severity: normal

Tags: patch

Found in version live-boot/3.0~a35-1

Fixed in version live-boot/3.0~b1-1

Done: Daniel Baumann <daniel@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#681579; Package live-boot. (Sat, 14 Jul 2012 13:15:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Andreas B. Mundt" <andi.mundt@web.de>:
New Bug report received and forwarded. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Sat, 14 Jul 2012 13:15:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Andreas B. Mundt" <andi.mundt@web.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: live-boot + FAI fails: tmpfs seems to hide mounted image
Date: Sat, 14 Jul 2012 15:06:01 +0200
Package: live-boot
Severity: important

Dear everybody,

I described the situation already on the live-boot mailing list in
this thread:
     <URL:https://lists.debian.org/debian-live/2012/07/msg00052.html>

Bisecting [1] the code showed that the bad commit is f92f379a6e868bc [2]

The relevant part seems to be:

-	mkdir -p /overlay
+	# tmpfs file systems
+	touch /etc/fstab
+	mkdir -p /live
+	mount -t tmpfs tmpfs /live
+	mkdir -p /live/overlay

I am not familiar with the code, but the tmpfs seems to hide the cd-image
which is mounted at /live/image.  Trying to mount aufs fails, there is
no /live/image accessible anymore.  To test this hypothesis, I added
two lines after the tmpfs setup:

root@wheezy:~/live-boot# git diff
diff --git a/scripts/live b/scripts/live
index af8c12e..9eb37b2 100755
--- a/scripts/live
+++ b/scripts/live
@@ -957,6 +958,8 @@ setup_unionfs ()
        mkdir -p /live
        mount -t tmpfs tmpfs /live
        mkdir -p /live/overlay
+       mkdir -p /live/image
+       mount /dev/sr0 /live/image

        # Looking for persistence devices or files
        if [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ]

With this modification, live-boot works again as expected and the
problem with aufs vanishes.

I hope this observations help solving the issue in time for wheezy.

Best regards,

     Andi


[1] <URL:https://lists.debian.org/debian-live/2012/07/msg00091.html>
[2] <URL:http://live.debian.net/gitweb?p=live-boot.git;a=commitdiff;h=f92f379a6e868bc486c050ff5ca81c1707da7374>


-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-3-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.utf8, LC_CTYPE=en_US.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash




Severity set to 'normal' from 'important' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Sat, 14 Jul 2012 14:27:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#681579; Package live-boot. (Sun, 15 Jul 2012 08:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Andreas B. Mundt" <andi.mundt@web.de>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Sun, 15 Jul 2012 08:45:03 GMT) Full text and rfc822 format available.

Message #12 received at 681579@bugs.debian.org (full text, mbox):

From: "Andreas B. Mundt" <andi.mundt@web.de>
To: 681579@bugs.debian.org
Cc: control@bugs.debian.org
Subject: patch to illustrate/workaround
Date: Sun, 15 Jul 2012 10:38:34 +0200
tags 681579 patch
thanks

Hi,

find below a simple patch (for the debian branch) that illustrates the
problem and solves it for me.  Please review the patch carefully,
there might be better implementations instead of this workaround.

Thanks,

	Andi


diff --git a/scripts/boot/overlay.sh b/scripts/boot/overlay.sh
index cb12c4b..2ec9782 100755
--- a/scripts/boot/overlay.sh
+++ b/scripts/boot/overlay.sh
@@ -155,9 +155,15 @@ setup_unionfs ()

        # tmpfs file systems
        touch /etc/fstab
-       mkdir -p /live
-       mount -t tmpfs tmpfs /live
-       mkdir -p /live/overlay
+       if [ ! -d /live ]
+       then
+               mkdir -p /live
+               mount -t tmpfs tmpfs /live
+               mkdir -p /live/overlay
+       else
+               mkdir -p /live/overlay
+               mount -t tmpfs tmpfs /live/overlay
+       fi

        # Looking for persistence devices or files
        if [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ]



Added tag(s) patch. Request was from "Andreas B. Mundt" <andi.mundt@web.de> to control@bugs.debian.org. (Sun, 15 Jul 2012 08:45:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, andi.mundt@web.de, Debian Live Project <debian-live@lists.debian.org>:
Bug#681579; Package live-boot. (Tue, 17 Jul 2012 08:57:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>:
Extra info received and forwarded to list. Copy sent to andi.mundt@web.de, Debian Live Project <debian-live@lists.debian.org>. (Tue, 17 Jul 2012 08:57:08 GMT) Full text and rfc822 format available.

Message #19 received at 681579@bugs.debian.org (full text, mbox):

From: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
To: Debian Bug Tracking System <681579@bugs.debian.org>
Subject: Re: patch to illustrate/workaround
Date: Tue, 17 Jul 2012 10:35:57 +0200
Package: live-boot
Version: 3.0~a35-1
Followup-For: Bug #681579

Hi Andreas,

thank you very much for reporting this issue and even coming up
with a patch.

We're using FAI at our department to install our workstations and when
I recently created a new NFS root for installation on our new FAI
server I noticed installations didn't work anymore and I eventually
tracked down the problem to the issue you are describing. I can
therefore confirm this and hope that your patch or a modified
version finds it way into the live-boot package as soon as possible!

In the meantime, I will look into your patch and test it myself,
we're currently stuck to installing Wheezy over an old FAI
server with FAI 3.x.

Regards,

Adrian



Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Thu, 16 Aug 2012 10:36:03 GMT) Full text and rfc822 format available.

Notification sent to "Andreas B. Mundt" <andi.mundt@web.de>:
Bug acknowledged by developer. (Thu, 16 Aug 2012 10:36:03 GMT) Full text and rfc822 format available.

Message #24 received at 681579-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 681579-close@bugs.debian.org
Subject: Bug#681579: fixed in live-boot 3.0~b1-1
Date: Thu, 16 Aug 2012 10:32:43 +0000
Source: live-boot
Source-Version: 3.0~b1-1

We believe that the bug you reported is fixed in the latest version of
live-boot, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 681579@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-boot package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 16 Aug 2012 12:21:04 +0200
Source: live-boot
Binary: live-boot live-boot-doc live-boot-initramfs-tools
Architecture: source all
Version: 3.0~b1-1
Distribution: unstable
Urgency: low
Maintainer: Debian Live Project <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-boot  - Debian Live - System Boot Scripts
 live-boot-doc - Debian Live - System Boot Scripts (documentation)
 live-boot-initramfs-tools - Debian Live - System Boot Scripts (initramfs-tools backend)
Closes: 681579 683240
Changes: 
 live-boot (3.0~b1-1) unstable; urgency=low
 .
   [ chals ]
   * Fixing build error in 'es' man pages caused by a newline conflict.
 .
   [ Daniel Baumann ]
   * Removing live-new-uuid, a rewritten one goes to live-tools.
   * Adding slightly modified patch from Steven Shiau
     <steven@nchc.org.tw> to transition to /run for network interface
     definition files which fixes resolv.conf creation for netboot.
 .
   [ Steven Shiau ]
   * Reading /conf/param.conf after Select_eth_device in main function to
     fix network booting (Closes: #683240).
 .
   [ Daniel Baumann ]
   * Moving reading of initramfs-tools functions to initramfs-tools
     script.
   * Consistently using case instead of if for conditionals in script
     boilerplate.
   * Laying tmpfs on /live/overlay only during initramfs stage, fixes
     boot failure with plain filesystems (Closes: #681579).
   * Correcting DNS inclusion in initramfs-tools hook, thanks to Steven
     Shiau <steven@nchc.org.tw> for reporting.
   * Simplifying usage of copy_exec function from hooks-function in
     initramfs-tools hook.
   * Using /etc/live/boot/*.conf instead of /etc/live/boot.d/*.conf and
     /live/image/live/boot/*.conf instead of
     /live/image/live/boot.d/*.conf for consistency reasons.
   * Reading configuration file from filesystem and live-media at runtime
     too.
   * Reading configuration files in initramfs-tools hook too.
 .
   [ Steven Shiau ]
   * Adding support for nameserver in ip= boot parameter.
 .
   [ Daniel Baumann ]
   * Making nameserver assignment from ip= bootparameter work with
     persistence.
   * Correcting permissions of /tmp which apparently somehow get mixed up
     along the way.
   * Updating scripts readme about transition to plugin based
     architecture.
Checksums-Sha1: 
 bc206822cfe435fa0fe9fa6fd6ac6f32c91019f4 1376 live-boot_3.0~b1-1.dsc
 ba3e237a5cbeb008b74801e619751d909d1824b0 59168 live-boot_3.0~b1.orig.tar.xz
 281909b5b385d8daf21a34ecfb48fbbeeac146c4 20828 live-boot_3.0~b1-1.debian.tar.xz
 5c995f8fa649551acf3114ca84e5b270c19a6cee 46452 live-boot_3.0~b1-1_all.deb
 6fd54f17076705b416d0471122dbeee4a92a66e0 50348 live-boot-doc_3.0~b1-1_all.deb
 d73f7394f2f3187e4c1351c40d0ecd48e7d1fdd5 24638 live-boot-initramfs-tools_3.0~b1-1_all.deb
Checksums-Sha256: 
 780f663acd95e9019669a7b0d0826ee4248a4151a715e4c24be308dfa77f18d3 1376 live-boot_3.0~b1-1.dsc
 186f72d7cf1032faac4280c80cfab67a261ea3aea31c2f8fb725b928a71ff0ad 59168 live-boot_3.0~b1.orig.tar.xz
 cc0317eb0d80444f8b778ce8b2fe51f2a77cbd076270918038e74ac16e1d9547 20828 live-boot_3.0~b1-1.debian.tar.xz
 82f8693326ba62f27a3083db2f1664356ab66e6047448b35bdfca12d37b4f211 46452 live-boot_3.0~b1-1_all.deb
 7c23bf688f17c8c45a9879f2b12563e7a434e823a5c26f4a710f19eceb42c24e 50348 live-boot-doc_3.0~b1-1_all.deb
 2906d3337262845ecdcbdc59db7982b35e23f0e9713ac19cacfb5365767a4302 24638 live-boot-initramfs-tools_3.0~b1-1_all.deb
Files: 
 8c2ec527c5cbe7fc8988d425d0e653cf 1376 misc optional live-boot_3.0~b1-1.dsc
 e6303d2bc2d7b7aa63c323760abede96 59168 misc optional live-boot_3.0~b1.orig.tar.xz
 048ebef189a521c9ca96bfdfba4ad66d 20828 misc optional live-boot_3.0~b1-1.debian.tar.xz
 fd4e19856800da47c2b38b0e8a7ea1d3 46452 misc optional live-boot_3.0~b1-1_all.deb
 1497e01462b6d5b8b3e62d8d506ef505 50348 doc optional live-boot-doc_3.0~b1-1_all.deb
 ee0c8f421c30fff0a3a9608508efe87a 24638 misc optional live-boot-initramfs-tools_3.0~b1-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAlAsy1sACgkQ+C5cwEsrK57LfgCdFlZ6MgzcvxZKjbhEHLX6kihU
N8gAn2PoLS20bPMc7zkO8trGTH+p2X+i
=TzIU
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 02 Mar 2013 07:27:55 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 18:30:19 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.